ForwardingMultimap
Date: 2016-05-24

com.google.common.collect

## Class ForwardingMultimap<K,V>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingMultimap<K,V>

- All Implemented Interfaces:
    Multimap<K,V>
  Direct Known Subclasses:
    ForwardingListMultimap, ForwardingSetMultimap

      @GwtCompatible
      public abstract class ForwardingMultimap<K,V>
      extends ForwardingObject
      implements Multimap<K,V>

  A multimap which forwards all its method calls to another multimap. Subclasses should override one or more methods to modify the behavior of the backing multimap as desired per the decorator pattern.
  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingMultimap()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Map<K,java.util.Collection<V>>` | `asMap()` Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values.
    `void` | `clear()` Removes all key-value pairs from the multimap, leaving it empty.
    `boolean` | `containsEntry(java.lang.Object key, java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
    `boolean` | `containsKey(java.lang.Object key)` Returns `true` if this multimap contains at least one key-value pair with the key `key`.
    `boolean` | `containsValue(java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the value `value`.
    `protected abstract Multimap<K,V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `java.util.Collection<java.util.Map.Entry<K,V>>` | `entries()` Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.
    `boolean` | `equals(java.lang.Object object)` Compares the specified object with this multimap for equality.
    `java.util.Collection<V>` | `get(K key)` Returns a view collection of the values associated with `key` in this multimap, if any.
    `int` | `hashCode()` Returns the hash code for this multimap.
    `boolean` | `isEmpty()` Returns `true` if this multimap contains no key-value pairs.
    `Multiset<K>` | `keys()` Returns a view collection containing the key from each key-value pair in this multimap, without collapsing duplicates.
    `java.util.Set<K>` | `keySet()` Returns a view collection of all distinct keys contained in this multimap.
    `boolean` | `put(K key, V value)` Stores a key-value pair in this multimap.
    `boolean` | `putAll(K key, java.lang.Iterable<? extends V> values)` Stores a key-value pair in this multimap for each of `values`, all using the same key, `key`.
    `boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Stores all key-value pairs of `multimap` in this multimap, in the order returned by `multimap.entries()`.
    `boolean` | `remove(java.lang.Object key, java.lang.Object value)` Removes a single key-value pair with the key `key` and the value `value` from this multimap, if such exists.
    `java.util.Collection<V>` | `removeAll(java.lang.Object key)` Removes all values associated with the key `key`.
    `java.util.Collection<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
    `int` | `size()` Returns the number of key-value pairs in this multimap.
    `java.util.Collection<V>` | `values()` Returns a view collection containing the value from each key-value pair contained in this multimap, without collapsing duplicates (so `values().size() == size()`).

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ForwardingMultimap

          protected ForwardingMultimap()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract Multimap<K,V> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingObject`

    - #### asMap

          public java.util.Map<K,java.util.Collection<V>> asMap()

      Description copied from interface: `Multimap`
      Returns a view of this multimap as a `Map` from each distinct key to the nonempty collection of that key's associated values. Note that `this.asMap().get(k)` is equivalent to `this.get(k)` only when `k` is a key contained in the multimap; otherwise it returns `null` as opposed to an empty collection.

      Changes to the returned map or the collections that serve as its values will update the underlying multimap, and vice versa. The map does not support `put` or `putAll`, nor do its entries support `setValue`.

      Specified by:
        `asMap` in interface `Multimap<K,V>`

    - #### clear

          public void clear()

      Description copied from interface: `Multimap`
      Removes all key-value pairs from the multimap, leaving it empty.
      Specified by:
        `clear` in interface `Multimap<K,V>`

    - #### containsEntry

          public boolean containsEntry(@Nullable
                              java.lang.Object key,
                              @Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
      Specified by:
        `containsEntry` in interface `Multimap<K,V>`

    - #### containsKey

          public boolean containsKey(@Nullable
                            java.lang.Object key)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key`.
      Specified by:
        `containsKey` in interface `Multimap<K,V>`

    - #### containsValue

          public boolean containsValue(@Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the value `value`.
      Specified by:
        `containsValue` in interface `Multimap<K,V>`

    - #### entries

          public java.util.Collection<java.util.Map.Entry<K,V>> entries()

      Description copied from interface: `Multimap`
      Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.

      Changes to the returned collection or the entries it contains will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      Specified by:
        `entries` in interface `Multimap<K,V>`

    - #### get

          public java.util.Collection<V> get(@Nullable
                                    K key)

      Description copied from interface: `Multimap`
      Returns a view collection of the values associated with `key` in this multimap, if any. Note that when `containsKey(key)` is false, this returns an empty collection, not `null`.

      Changes to the returned collection will update the underlying multimap, and vice versa.

      Specified by:
        `get` in interface `Multimap<K,V>`

    - #### isEmpty

          public boolean isEmpty()

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains no key-value pairs. Equivalent to `size() == 0`, but can in some cases be more efficient.
      Specified by:
        `isEmpty` in interface `Multimap<K,V>`

    - #### keys

          public Multiset<K> keys()

      Description copied from interface: `Multimap`
      Returns a view collection containing the key from each key-value pair in this multimap, without collapsing duplicates. This collection has the same size as this multimap, and `keys().count(k) == get(k).size()` for all `k`.

      Changes to the returned multiset will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      Specified by:
        `keys` in interface `Multimap<K,V>`

    - #### keySet

          public java.util.Set<K> keySet()

      Description copied from interface: `Multimap`
      Returns a view collection of all distinct keys contained in this multimap. Note that the key set contains a key if and only if this multimap maps that key to at least one value.

      Changes to the returned set will update the underlying multimap, and vice versa. However, adding to the returned set is not possible.

      Specified by:
        `keySet` in interface `Multimap<K,V>`

    - #### put

          public boolean put(K key,
                    V value)

      Description copied from interface: `Multimap`
      Stores a key-value pair in this multimap.

      Some multimap implementations allow duplicate key-value pairs, in which case `put` always adds a new key-value pair and increases the multimap size by 1. Other implementations prohibit duplicates, and storing a key-value pair that's already in the multimap has no effect.

      Specified by:
        `put` in interface `Multimap<K,V>`
      Returns:
        `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair and doesn't allow duplicates

    - #### putAll

          public boolean putAll(K key,
                       java.lang.Iterable<? extends V> values)

      Description copied from interface: `Multimap`
      Stores a key-value pair in this multimap for each of `values`, all using the same key, `key`. Equivalent to (but expected to be more efficient than):

             for (V value : values) {
               put(key, value);
             }

      In particular, this is a no-op if `values` is empty.

      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### putAll

          public boolean putAll(Multimap<? extends K,? extends V> multimap)

      Description copied from interface: `Multimap`
      Stores all key-value pairs of `multimap` in this multimap, in the order returned by `multimap.entries()`.
      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### remove

          public boolean remove(@Nullable
                       java.lang.Object key,
                       @Nullable
                       java.lang.Object value)

      Description copied from interface: `Multimap`
      Removes a single key-value pair with the key `key` and the value `value` from this multimap, if such exists. If multiple key-value pairs in the multimap fit this description, which one is removed is unspecified.
      Specified by:
        `remove` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed

    - #### removeAll

          public java.util.Collection<V> removeAll(@Nullable
                                          java.lang.Object key)

      Description copied from interface: `Multimap`
      Removes all values associated with the key `key`.

      Once this method returns, `key` will not be mapped to any values, so it will not appear in `Multimap.keySet()`, `Multimap.asMap()`, or any other views.

      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.

    - #### replaceValues

          public java.util.Collection<V> replaceValues(K key,
                                              java.lang.Iterable<? extends V> values)

      Description copied from interface: `Multimap`
      Stores a collection of values with the same key, replacing any existing values for that key.

      If `values` is empty, this is equivalent to `removeAll(key)`.

      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

    - #### size

          public int size()

      Description copied from interface: `Multimap`
      Returns the number of key-value pairs in this multimap.

      Note: this method does not return the number of distinct keys in the multimap, which is given by `keySet().size()` or `asMap().size()`. See the opening section of the `Multimap` class documentation for clarification.

      Specified by:
        `size` in interface `Multimap<K,V>`

    - #### values

          public java.util.Collection<V> values()

      Description copied from interface: `Multimap`
      Returns a view collection containing the value from each key-value pair contained in this multimap, without collapsing duplicates (so `values().size() == size()`).

      Changes to the returned collection will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      Specified by:
        `values` in interface `Multimap<K,V>`

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object object)

      Description copied from interface: `Multimap`
      Compares the specified object with this multimap for equality. Two multimaps are equal when their map views, as returned by `Multimap.asMap()`, are also equal.

      In general, two multimaps with identical key-value mappings may or may not be equal, depending on the implementation. For example, two `SetMultimap` instances with the same key-value mappings are equal, but equality of two `ListMultimap` instances depends on the ordering of the values for each key.

      A non-empty `SetMultimap` cannot be equal to a non-empty `ListMultimap`, since their `Multimap.asMap()` views contain unequal collections as values. However, any two empty multimaps are equal, because they both have empty `Multimap.asMap()` views.

      Specified by:
        `equals` in interface `Multimap<K,V>`
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Description copied from interface: `Multimap`
      Returns the hash code for this multimap.

      The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

      In general, two multimaps with identical key-value mappings may or may not have the same hash codes, depending on the implementation. For example, two `SetMultimap` instances with the same key-value mappings will have the same `hashCode`, but the `hashCode` of `ListMultimap` instances depends on the ordering of the values for each key.

      Specified by:
        `hashCode` in interface `Multimap<K,V>`
      Overrides:
        `hashCode` in class `java.lang.Object`